#!/usr/bin/python

import os
import sys

import argparse
from PIL import Image

def skrij(kopica, dolzina, igla):
    pos = 0
    igla = dolzina.to_bytes(4, byteorder='little') + igla
    for znak in igla:
        for bi in range(8):
            bit = min(znak & (1 << bi), 1)
            orig = kopica[pos] 
            novi = orig & 0xfffffe | bit
            kopica[pos] = novi
            pos += 1
            
def __izvleci(kopica, dolzina):
    pos = 0
    rezultat = bytearray(dolzina)
    znak = 0
    for pos in range(8*dolzina):
        pika = kopica[pos]
        b = pika & 1
        # print(pika, b)
        znak = znak + (b << (pos % 8))
        if (pos % 8) == 7:
            # print(znak)
            rezultat[pos // 8] = znak
            znak = 0
    return rezultat

def izvleci(kopica):
    dolzina_bytes = __izvleci(kopica, 4)
    dolzina = int.from_bytes(dolzina_bytes, byteorder='little')
    if dolzina > 10000000:
        print("PREVEC!")
        return b""
    return __izvleci(kopica[4*8:], dolzina)

if __name__ == '__main__':
    p = argparse.ArgumentParser()
    p.add_argument("-i", "--input", type=str, help="datoteka s podatki")
    p.add_argument("image", help="slika, v katero skrivamo")
    args = p.parse_args()
    with Image.open(args.image) as original:
        kopica = bytearray(original.tobytes())
        if args.input:
            with open(args.input, 'rb') as vhod:
                igla = vhod.read()
                d = len(igla)
                skrij(kopica, d, igla)
            podatki = izvleci(kopica)
            # print(podatki)
            original.frombytes(bytes(kopica))
            original.save(original.filename)
        else:
            podatki = izvleci(kopica)
            fp = os.fdopen(sys.stdout.fileno(), 'wb', closefd=False)
            fp.write(bytes(podatki))
            fp.flush()

